#lang racket
(require rackunit)
(require "stream.rkt")
(require "stream-map.rkt")
(require "naturals.rkt")
(require "even-nats.rkt")
(require "stream-zip.rkt")
(require "stream-filter.rkt")
(require "stream-enum.rkt")

(define (stream-drop-1 s)
  ; for each e yield (i, e)
  (define enum-s (stream-enum s))
  ; given (i, e) only keep (even? i)
  (define even-s
    (stream-filter
      ;(lambda (x) (even? (car x)))
      (compose even? car)
      enum-s))
  ; convert (i, e) back to e
  (stream-map cdr even-s))


(define s0 (stream-drop-1 (naturals)))
(check-equal? 0 (stream-get s0))

(define s1 (stream-next s0))
(check-equal? 2 (stream-get s1))

(define s2 (stream-next s1))
(check-equal? 4 (stream-get s2))
