#lang racket
(require rackunit)
;----------------------------------------------------
; Slide 8
; -------
(define (powers-of-two)
  (define (powers-of-two-iter n)
    (thunk
      (cons n (powers-of-two-iter (* 2 n)))))
  ((powers-of-two-iter 1)))











;------------------------------------------------
; Slide 5
; -------
(check-equal? 1 (car (powers-of-two)))                 ; the 1st element of the stream
(check-equal? 2 (car ((cdr (powers-of-two)))))         ; the 2nd element of the stream
(check-equal? 4 (car ((cdr ((cdr (powers-of-two))))))) ; the 3rd element of the stream
#|
powers-of-two
(powers-of-two)
(car (powers-of-two))
(cdr (powers-of-two))
; (thunk (cons 1 ?))
(define p-2 (cdr (powers-of-two)))
p-2
(p-2)
|#

#|
(define (stream-first s) (car s))
(define (stream-rest s) ((cdr s)))
(check-equal? 1 (stream-first (powers-of-two)))                 ; the 1st element of the stream
(check-equal? 2 (stream-first (stream-rest (powers-of-two))))         ; the 2nd element of the stream
(check-equal? 4 (stream-first (stream-rest (stream-rest (powers-of-two))))) ; the 3rd element of the stream
|#











; -----------------------------------------------------------
; Slide 6
; -------
; Revisiting our example with helper functions
; Retrieves the current value of the stream
(define (stream-get stream) (car stream))
; Retrieves the thunk and evaluates it, returning a thunk
(define (stream-next stream) ((cdr stream)))
(check-equal? 1 (stream-get (powers-of-two)))
(check-equal? 2 (stream-get (stream-next (powers-of-two))))
(check-equal? 4 (stream-get (stream-next (stream-next (powers-of-two)))))


#|
(define (count-until:2 stream pred?)
  (cond [(pred? (stream-get stream))
         (+ 1 (count-until:2 (stream-next stream) pred?)) ]
        [else 0]))
(count-until:2 (powers-of-two) (lambda (x) (< x 8)))

(count-until:2 (powers-of-two) (lambda (x) #f))
;(count-until:2 (powers-of-two) (lambda (x)
;  (display x) (newline) #t))
|#
#|
(define (pow2)
  (define (pow2-iter n)
    (display n)(newline)
    (cons n (thunk (pow2-iter (* 2 n)))))
  (pow2-iter 1))

; (cons 1 empty)
; (cons 1 2)

(pow2)
|#


;-----------------------------------------------------
(define (count-until stream pred)
  (define (count-until-iter s count)
    (cond [(pred (stream-get s)) (count-until-iter (stream-next s) (+ count 1))]
          [else count]))
  (count-until-iter stream 0))

















;---------------------------------------------------------
; Slide 7
; -------
; Programming with streams
(check-equal? 3 (count-until (powers-of-two) (lambda (x) (< x 8))))
(check-equal? 0 (count-until (powers-of-two) (lambda (x) (<= x 0))))
(check-equal? 3 (count-until (powers-of-two) (curryr < 8)))
(check-equal? 0 (count-until (powers-of-two) (curryr <= 0)))






(define (const k)
  (cons k (thunk (const k))))

(stream-get (const 10))
(stream-get (stream-next (stream-next (const 10))))


(define (nat)
  (define (nat-iter n)
    (cons n (thunk (nat-iter (+ n 1)))))
  (nat-iter 0))


(define (s-map f stream)
  (cons (f (stream-get stream))
        (thunk (s-map f (stream-next stream)))))


(define even (s-map (lambda (x) (* x 2)) (nat)))

(stream-get even)
(stream-get (stream-next even))
(stream-get (stream-next (stream-next even)))
















;