#lang racket

(struct promise (empty? result))
(define (make-promise thunk) (promise #t thunk))
(define (promise-run w)
  (define th (promise-result w))
  (th))
(define (promise-get p)
  (cond [(promise-empty? p) (error "promise: call (promise-sync p) first.")]
        [else (promise-result p)]))
(define (promise-sync p)
  (cond [(promise-empty? p) p]
        [else (promise #t (promise-run p))]))

(define (promise-repeat n prom)
  (cond [(<= n 0) (void)]
        [else
          (promise-repeat (- n 1) (promise-sync prom))]))
(promise-repeat 3 (make-promise (thunk (sleep 1) 3)))
