#lang racket
(require rackunit)
(require "stream.rkt")
(require "naturals.rkt")
(provide stream-filter)
(define (stream-filter pred s)
  (define (stream-filter-iter s)
    (thunk
      ; Get the head of the stream
      (define h (stream-get s))
      ; Filter the rest of the stream
      (define next
        (stream-filter-iter
          (stream-next s)))
      ; Predicate holds, then return h
      (cond [(pred h) (cons h next)]
            ; Otherwise, unfold the stream
            [else (next)])))
  ((stream-filter-iter s)))



(define s0
  (stream-filter (curry <= 10)
    (naturals)))

(check-equal? (stream-get s0) 10)
(define s1 (stream-next s0))
(check-equal? (stream-get s1) 11)
(define s2 (stream-next s1))
(check-equal? (stream-get s2) 12)

