#lang errortrace racket
(require "stream.rkt")
(require "naturals.rkt")
(require rackunit)
(provide stream-map)

(define (stream-map f s)
  (define (stream-map-iter s)
    (thunk
      (cons
        (f (stream-get s))
        (stream-map-iter (stream-next s)))))
  ((stream-map-iter s)))


(define s1 (stream-map (curry + 2) (naturals)))
(check-equal? (stream-get s1) 2)
(define s2 (stream-next s1))
(check-equal? (stream-get s2) 3)
(define s3 (stream-next s2))
(check-equal? (stream-get s3) 4)
