#lang racket
(require "stream.rkt")
(require "stream-map.rkt")
(require "naturals.rkt")
(require "even-nats.rkt")
(provide stream-zip)
(define (stream-zip s1 s2)
  (define (stream-zip-iter s1 s2)
    (thunk
      (cons
        (cons (stream-get s1)
              (stream-get s2))
        (stream-zip-iter
          (stream-next s1)
          (stream-next s2)))))
  ((stream-zip-iter s1 s2)))


(require rackunit)
(define s0
  (stream-zip (naturals) (even-naturals)))

(check-equal? (cons 0 0) (stream-get s0))

(define s1 (stream-next s0))
(check-equal? (cons 1 2) (stream-get s1))

(define s2 (stream-next s1))
(check-equal? (cons 2 4) (stream-get s2))
